/**
 */
package org.xtextcasts.edsl.example.model;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each operation of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see org.xtextcasts.edsl.example.model.ModelFactory
 * @model kind="package"
 *        annotation="http://www.eclipse.org/emf/2002/GenModel basePackage='org.xtextcasts.edsl.example'"
 * @generated
 */
public interface ModelPackage extends EPackage
{
  /**
   * The package name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNAME = "model";

  /**
   * The package namespace URI.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_URI = "org.xtextcasts.edsl.example.model";

  /**
   * The package namespace name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_PREFIX = "model";

  /**
   * The singleton instance of the package.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  ModelPackage eINSTANCE = org.xtextcasts.edsl.example.model.impl.ModelPackageImpl.init();

  /**
   * The meta object id for the '{@link org.xtextcasts.edsl.example.model.impl.RegistrationFormImpl <em>Registration Form</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.xtextcasts.edsl.example.model.impl.RegistrationFormImpl
   * @see org.xtextcasts.edsl.example.model.impl.ModelPackageImpl#getRegistrationForm()
   * @generated
   */
  int REGISTRATION_FORM = 0;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int REGISTRATION_FORM__NAME = 0;

  /**
   * The feature id for the '<em><b>Email</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int REGISTRATION_FORM__EMAIL = 1;

  /**
   * The feature id for the '<em><b>Age</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int REGISTRATION_FORM__AGE = 2;

  /**
   * The feature id for the '<em><b>City</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int REGISTRATION_FORM__CITY = 3;

  /**
   * The feature id for the '<em><b>Zip</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int REGISTRATION_FORM__ZIP = 4;

  /**
   * The feature id for the '<em><b>Country</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int REGISTRATION_FORM__COUNTRY = 5;

  /**
   * The number of structural features of the '<em>Registration Form</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int REGISTRATION_FORM_FEATURE_COUNT = 6;

  /**
   * The number of operations of the '<em>Registration Form</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int REGISTRATION_FORM_OPERATION_COUNT = 0;


  /**
   * Returns the meta object for class '{@link org.xtextcasts.edsl.example.model.RegistrationForm <em>Registration Form</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Registration Form</em>'.
   * @see org.xtextcasts.edsl.example.model.RegistrationForm
   * @generated
   */
  EClass getRegistrationForm();

  /**
   * Returns the meta object for the attribute '{@link org.xtextcasts.edsl.example.model.RegistrationForm#getName <em>Name</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Name</em>'.
   * @see org.xtextcasts.edsl.example.model.RegistrationForm#getName()
   * @see #getRegistrationForm()
   * @generated
   */
  EAttribute getRegistrationForm_Name();

  /**
   * Returns the meta object for the attribute '{@link org.xtextcasts.edsl.example.model.RegistrationForm#getEmail <em>Email</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Email</em>'.
   * @see org.xtextcasts.edsl.example.model.RegistrationForm#getEmail()
   * @see #getRegistrationForm()
   * @generated
   */
  EAttribute getRegistrationForm_Email();

  /**
   * Returns the meta object for the attribute '{@link org.xtextcasts.edsl.example.model.RegistrationForm#getAge <em>Age</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Age</em>'.
   * @see org.xtextcasts.edsl.example.model.RegistrationForm#getAge()
   * @see #getRegistrationForm()
   * @generated
   */
  EAttribute getRegistrationForm_Age();

  /**
   * Returns the meta object for the attribute '{@link org.xtextcasts.edsl.example.model.RegistrationForm#getCity <em>City</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>City</em>'.
   * @see org.xtextcasts.edsl.example.model.RegistrationForm#getCity()
   * @see #getRegistrationForm()
   * @generated
   */
  EAttribute getRegistrationForm_City();

  /**
   * Returns the meta object for the attribute '{@link org.xtextcasts.edsl.example.model.RegistrationForm#getZip <em>Zip</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Zip</em>'.
   * @see org.xtextcasts.edsl.example.model.RegistrationForm#getZip()
   * @see #getRegistrationForm()
   * @generated
   */
  EAttribute getRegistrationForm_Zip();

  /**
   * Returns the meta object for the attribute '{@link org.xtextcasts.edsl.example.model.RegistrationForm#getCountry <em>Country</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Country</em>'.
   * @see org.xtextcasts.edsl.example.model.RegistrationForm#getCountry()
   * @see #getRegistrationForm()
   * @generated
   */
  EAttribute getRegistrationForm_Country();

  /**
   * Returns the factory that creates the instances of the model.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the factory that creates the instances of the model.
   * @generated
   */
  ModelFactory getModelFactory();

  /**
   * <!-- begin-user-doc -->
   * Defines literals for the meta objects that represent
   * <ul>
   *   <li>each class,</li>
   *   <li>each feature of each class,</li>
   *   <li>each operation of each class,</li>
   *   <li>each enum,</li>
   *   <li>and each data type</li>
   * </ul>
   * <!-- end-user-doc -->
   * @generated
   */
  interface Literals
  {
    /**
     * The meta object literal for the '{@link org.xtextcasts.edsl.example.model.impl.RegistrationFormImpl <em>Registration Form</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.xtextcasts.edsl.example.model.impl.RegistrationFormImpl
     * @see org.xtextcasts.edsl.example.model.impl.ModelPackageImpl#getRegistrationForm()
     * @generated
     */
    EClass REGISTRATION_FORM = eINSTANCE.getRegistrationForm();

    /**
     * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute REGISTRATION_FORM__NAME = eINSTANCE.getRegistrationForm_Name();

    /**
     * The meta object literal for the '<em><b>Email</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute REGISTRATION_FORM__EMAIL = eINSTANCE.getRegistrationForm_Email();

    /**
     * The meta object literal for the '<em><b>Age</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute REGISTRATION_FORM__AGE = eINSTANCE.getRegistrationForm_Age();

    /**
     * The meta object literal for the '<em><b>City</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute REGISTRATION_FORM__CITY = eINSTANCE.getRegistrationForm_City();

    /**
     * The meta object literal for the '<em><b>Zip</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute REGISTRATION_FORM__ZIP = eINSTANCE.getRegistrationForm_Zip();

    /**
     * The meta object literal for the '<em><b>Country</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute REGISTRATION_FORM__COUNTRY = eINSTANCE.getRegistrationForm_Country();

  }

} //ModelPackage
