package org.xtextcasts.edsl.example.edsl

import org.eclipse.emf.ecore.EAttribute

class ElementDef{}

class GroupDef extends ElementDef {
	@Property
	val elementList = <ElementDef>newArrayList
	
	@Property
	String text
	
	
	def textInput(EAttribute attribute, String label) {
		elementList.add(new TextInputDef => [
			it.label = label
			it.attribute = attribute
		])
	}
	def numberInput(EAttribute attribute, String label) {
		numberInput(attribute, label, null)
	}
	def numberInput(EAttribute attribute, String label, (NumberInputDef) => void proc) {
		elementList.add(new NumberInputDef => [
			it.label = label
			it.attribute = attribute
			if (proc != null) {
				proc.apply(it)
			}
		])
	}
}

class InputDef extends ElementDef {
	@Property
	EAttribute attribute
	
	@Property
	String label
}

class TextInputDef extends InputDef {}

class NumberInputDef extends InputDef {
	@Property
	Integer maximum
	
	@Property
	Integer minimum
}
