package org.xtextcasts.edsl.example;

import com.google.common.base.Objects;
import java.util.ArrayList;
import java.util.Arrays;
import org.eclipse.core.databinding.DataBindingContext;
import org.eclipse.core.databinding.observable.Realm;
import org.eclipse.core.databinding.observable.value.IObservableValue;
import org.eclipse.emf.databinding.EMFProperties;
import org.eclipse.emf.databinding.IEMFValueProperty;
import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.jface.databinding.swt.ISWTObservableValue;
import org.eclipse.jface.databinding.swt.IWidgetValueProperty;
import org.eclipse.jface.databinding.swt.SWTObservables;
import org.eclipse.jface.databinding.swt.WidgetProperties;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Spinner;
import org.eclipse.swt.widgets.Text;
import org.eclipse.xtext.xbase.lib.Functions.Function0;
import org.eclipse.xtext.xbase.lib.InputOutput;
import org.eclipse.xtext.xbase.lib.ObjectExtensions;
import org.eclipse.xtext.xbase.lib.Procedures.Procedure1;
import org.xtextcasts.edsl.example.OnSelect;
import org.xtextcasts.edsl.example.edsl.ElementDef;
import org.xtextcasts.edsl.example.edsl.GroupDef;
import org.xtextcasts.edsl.example.edsl.NumberInputDef;
import org.xtextcasts.edsl.example.edsl.TextInputDef;
import org.xtextcasts.edsl.example.forms.MyForm;
import org.xtextcasts.edsl.example.model.ModelFactory;
import org.xtextcasts.edsl.example.model.ModelPackage;
import org.xtextcasts.edsl.example.model.RegistrationForm;

@SuppressWarnings("all")
public class Main {
  private Shell shell;
  
  private RegistrationForm model;
  
  private final DataBindingContext bindingContext = new Function0<DataBindingContext>() {
    public DataBindingContext apply() {
      DataBindingContext _dataBindingContext = new DataBindingContext();
      return _dataBindingContext;
    }
  }.apply();
  
  public Main(final Shell shell, final RegistrationForm form) {
    this.shell = shell;
    this.model = form;
  }
  
  public static void main(final String[] args) {
    Display _display = new Display();
    final Display display = _display;
    Shell _shell = new Shell(display);
    final Shell shell = _shell;
    GridLayout _gridLayout = new GridLayout(1, false);
    shell.setLayout(_gridLayout);
    ModelPackage.eINSTANCE.eClass();
    final ModelFactory factory = ModelFactory.eINSTANCE;
    final RegistrationForm form = factory.createRegistrationForm();
    Realm _realm = SWTObservables.getRealm(display);
    final Runnable _function = new Runnable() {
        public void run() {
          Main _main = new Main(shell, form);
          MyForm _myForm = new MyForm();
          _main.constructForm(_myForm);
          shell.pack();
          shell.open();
          boolean _isDisposed = shell.isDisposed();
          boolean _not = (!_isDisposed);
          boolean _while = _not;
          while (_while) {
            boolean _readAndDispatch = display.readAndDispatch();
            boolean _not_1 = (!_readAndDispatch);
            if (_not_1) {
              display.sleep();
            }
            boolean _isDisposed_1 = shell.isDisposed();
            boolean _not_2 = (!_isDisposed_1);
            _while = _not_2;
          }
          display.dispose();
        }
      };
    Realm.runWithDefault(_realm, _function);
  }
  
  public void constructForm(final MyForm myForm) {
    myForm.specifyForm();
    String _elvis = null;
    String _title = myForm.getTitle();
    if (_title != null) {
      _elvis = _title;
    } else {
      _elvis = ObjectExtensions.<String>operator_elvis(_title, "");
    }
    this.shell.setText(_elvis);
    GridLayout _gridLayout = new GridLayout(1, false);
    this.shell.setLayout(_gridLayout);
    GroupDef _form = myForm.getForm();
    ArrayList<ElementDef> _elementList = _form.getElementList();
    for (final ElementDef elementDef : _elementList) {
      this.constructElement(elementDef, this.shell);
    }
    Composite _composite = new Composite(this.shell, SWT.NONE);
    final Procedure1<Composite> _function = new Procedure1<Composite>() {
        public void apply(final Composite it) {
          GridLayout _gridLayout = new GridLayout(2, false);
          it.setLayout(_gridLayout);
          GridData _gridData = new GridData(SWT.RIGHT, SWT.BOTTOM, true, true);
          it.setLayoutData(_gridData);
          Button _button = new Button(it, SWT.NONE);
          final Procedure1<Button> _function = new Procedure1<Button>() {
              public void apply(final Button it) {
                it.setText("OK");
                final Procedure1<SelectionEvent> _function = new Procedure1<SelectionEvent>() {
                    public void apply(final SelectionEvent it) {
                      InputOutput.<RegistrationForm>println(Main.this.model);
                      System.exit(0);
                    }
                  };
                Main.onSelect(it, _function);
              }
            };
          ObjectExtensions.<Button>operator_doubleArrow(_button, _function);
          Button _button_1 = new Button(it, SWT.NONE);
          final Procedure1<Button> _function_1 = new Procedure1<Button>() {
              public void apply(final Button it) {
                it.setText("Cancel");
                final Procedure1<SelectionEvent> _function = new Procedure1<SelectionEvent>() {
                    public void apply(final SelectionEvent it) {
                      System.exit(0);
                    }
                  };
                Main.onSelect(it, _function);
              }
            };
          ObjectExtensions.<Button>operator_doubleArrow(_button_1, _function_1);
        }
      };
    ObjectExtensions.<Composite>operator_doubleArrow(_composite, _function);
  }
  
  protected void _constructElement(final GroupDef compositeDef, final Composite parent) {
    Group _group = new Group(parent, SWT.BORDER);
    final Group composite = _group;
    String _text = compositeDef.getText();
    composite.setText(_text);
    GridLayout _gridLayout = new GridLayout(2, false);
    composite.setLayout(_gridLayout);
    GridData _gridData = new GridData(SWT.FILL, SWT.FILL, true, false);
    composite.setLayoutData(_gridData);
    ArrayList<ElementDef> _elementList = compositeDef.getElementList();
    for (final ElementDef elementDef : _elementList) {
      this.constructElement(elementDef, composite);
    }
  }
  
  protected void _constructElement(final TextInputDef textInputDef, final Composite parent) {
    Label _label = new Label(parent, SWT.NONE);
    final Label label = _label;
    String _label_1 = textInputDef.getLabel();
    label.setText(_label_1);
    Text _text = new Text(parent, SWT.BORDER);
    final Text text = _text;
    GridData _gridData = new GridData(SWT.FILL, SWT.CENTER, true, false);
    final Procedure1<GridData> _function = new Procedure1<GridData>() {
        public void apply(final GridData it) {
          it.widthHint = 150;
        }
      };
    GridData _doubleArrow = ObjectExtensions.<GridData>operator_doubleArrow(_gridData, _function);
    text.setLayoutData(_doubleArrow);
    IWidgetValueProperty _text_1 = WidgetProperties.text(SWT.Modify);
    ISWTObservableValue _observe = _text_1.observe(text);
    EAttribute _attribute = textInputDef.getAttribute();
    IEMFValueProperty _value = EMFProperties.value(_attribute);
    IObservableValue _observe_1 = _value.observe(this.model);
    this.bindingContext.bindValue(_observe, _observe_1);
  }
  
  protected void _constructElement(final NumberInputDef numberInputDef, final Composite parent) {
    Label _label = new Label(parent, SWT.NONE);
    final Label label = _label;
    String _label_1 = numberInputDef.getLabel();
    label.setText(_label_1);
    Spinner _spinner = new Spinner(parent, SWT.BORDER);
    final Spinner spinner = _spinner;
    GridData _gridData = new GridData(SWT.FILL, SWT.CENTER, true, false);
    final Procedure1<GridData> _function = new Procedure1<GridData>() {
        public void apply(final GridData it) {
          it.widthHint = 150;
        }
      };
    GridData _doubleArrow = ObjectExtensions.<GridData>operator_doubleArrow(_gridData, _function);
    spinner.setLayoutData(_doubleArrow);
    Integer _maximum = numberInputDef.getMaximum();
    boolean _notEquals = (!Objects.equal(_maximum, null));
    if (_notEquals) {
      Integer _maximum_1 = numberInputDef.getMaximum();
      spinner.setMaximum((_maximum_1).intValue());
    }
    Integer _minimum = numberInputDef.getMinimum();
    boolean _notEquals_1 = (!Objects.equal(_minimum, null));
    if (_notEquals_1) {
      Integer _minimum_1 = numberInputDef.getMinimum();
      spinner.setMinimum((_minimum_1).intValue());
    }
    IWidgetValueProperty _selection = WidgetProperties.selection();
    ISWTObservableValue _observe = _selection.observe(spinner);
    EAttribute _attribute = numberInputDef.getAttribute();
    IEMFValueProperty _value = EMFProperties.value(_attribute);
    IObservableValue _observe_1 = _value.observe(this.model);
    this.bindingContext.bindValue(_observe, _observe_1);
  }
  
  public static void onSelect(final Button button, final Procedure1<? super SelectionEvent> proc) {
    OnSelect _onSelect = new OnSelect(proc);
    button.addSelectionListener(_onSelect);
  }
  
  public void constructElement(final ElementDef numberInputDef, final Composite parent) {
    if (numberInputDef instanceof NumberInputDef) {
      _constructElement((NumberInputDef)numberInputDef, parent);
      return;
    } else if (numberInputDef instanceof TextInputDef) {
      _constructElement((TextInputDef)numberInputDef, parent);
      return;
    } else if (numberInputDef instanceof GroupDef) {
      _constructElement((GroupDef)numberInputDef, parent);
      return;
    } else {
      throw new IllegalArgumentException("Unhandled parameter types: " +
        Arrays.<Object>asList(numberInputDef, parent).toString());
    }
  }
}
