package org.xtextcasts.edsl.example;

import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.xtend.lib.Data;
import org.eclipse.xtext.xbase.lib.Procedures.Procedure1;
import org.eclipse.xtext.xbase.lib.util.ToStringHelper;

@Data
@SuppressWarnings("all")
public class OnSelect implements SelectionListener {
  private final Procedure1<? super SelectionEvent> _proc;
  
  public Procedure1<? super SelectionEvent> getProc() {
    return this._proc;
  }
  
  public void widgetDefaultSelected(final SelectionEvent e) {
  }
  
  public void widgetSelected(final SelectionEvent e) {
    Procedure1<? super SelectionEvent> _proc = this.getProc();
    _proc.apply(e);
  }
  
  public OnSelect(final Procedure1<? super SelectionEvent> proc) {
    super();
    this._proc = proc;
  }
  
  @Override
  public int hashCode() {
    final int prime = 31;
    int result = 1;
    result = prime * result + ((_proc== null) ? 0 : _proc.hashCode());
    return result;
  }
  
  @Override
  public boolean equals(final Object obj) {
    if (this == obj)
      return true;
    if (obj == null)
      return false;
    if (getClass() != obj.getClass())
      return false;
    OnSelect other = (OnSelect) obj;
    if (_proc == null) {
      if (other._proc != null)
        return false;
    } else if (!_proc.equals(other._proc))
      return false;
    return true;
  }
  
  @Override
  public String toString() {
    String result = new ToStringHelper().toString(this);
    return result;
  }
}
