package org.xtextcasts.edsl.example.edsl;

import com.google.common.base.Objects;
import java.util.ArrayList;
import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.xtext.xbase.lib.CollectionLiterals;
import org.eclipse.xtext.xbase.lib.Functions.Function0;
import org.eclipse.xtext.xbase.lib.ObjectExtensions;
import org.eclipse.xtext.xbase.lib.Procedures.Procedure1;
import org.xtextcasts.edsl.example.edsl.ElementDef;
import org.xtextcasts.edsl.example.edsl.NumberInputDef;
import org.xtextcasts.edsl.example.edsl.TextInputDef;

@SuppressWarnings("all")
public class GroupDef extends ElementDef {
  private final ArrayList<ElementDef> _elementList = new Function0<ArrayList<ElementDef>>() {
    public ArrayList<ElementDef> apply() {
      ArrayList<ElementDef> _newArrayList = CollectionLiterals.<ElementDef>newArrayList();
      return _newArrayList;
    }
  }.apply();
  
  public ArrayList<ElementDef> getElementList() {
    return this._elementList;
  }
  
  private String _text;
  
  public String getText() {
    return this._text;
  }
  
  public void setText(final String text) {
    this._text = text;
  }
  
  public boolean textInput(final EAttribute attribute, final String label) {
    ArrayList<ElementDef> _elementList = this.getElementList();
    TextInputDef _textInputDef = new TextInputDef();
    final Procedure1<TextInputDef> _function = new Procedure1<TextInputDef>() {
        public void apply(final TextInputDef it) {
          it.setLabel(label);
          it.setAttribute(attribute);
        }
      };
    TextInputDef _doubleArrow = ObjectExtensions.<TextInputDef>operator_doubleArrow(_textInputDef, _function);
    boolean _add = _elementList.add(_doubleArrow);
    return _add;
  }
  
  public boolean numberInput(final EAttribute attribute, final String label) {
    boolean _numberInput = this.numberInput(attribute, label, null);
    return _numberInput;
  }
  
  public boolean numberInput(final EAttribute attribute, final String label, final Procedure1<? super NumberInputDef> proc) {
    ArrayList<ElementDef> _elementList = this.getElementList();
    NumberInputDef _numberInputDef = new NumberInputDef();
    final Procedure1<NumberInputDef> _function = new Procedure1<NumberInputDef>() {
        public void apply(final NumberInputDef it) {
          it.setLabel(label);
          it.setAttribute(attribute);
          boolean _notEquals = (!Objects.equal(proc, null));
          if (_notEquals) {
            proc.apply(it);
          }
        }
      };
    NumberInputDef _doubleArrow = ObjectExtensions.<NumberInputDef>operator_doubleArrow(_numberInputDef, _function);
    boolean _add = _elementList.add(_doubleArrow);
    return _add;
  }
}
